Last Comment Bug 309472 - Start of equations and diagrams not indicated in accessible tree
: Start of equations and diagrams not indicated in accessible tree
Status: RESOLVED FIXED
[ETA: need review ]
: access, fixed1.8, sec508
Product: Core
Classification: Components
Component: Disability Access APIs (show other bugs)
: Trunk
: x86 Windows XP
: -- normal (vote)
: mozilla1.8beta5
Assigned To: Aaron Leventhal
:
: alexander :surkov
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2005-09-21 07:30 PDT by Aaron Leventhal
Modified: 2005-10-05 12:45 PDT (History)
1 user (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Simple patch to expose ROLE_EQUATION for <math> or ROLE_DIAGRAM for <svg> (4.14 KB, patch)
2005-09-21 12:10 PDT, Aaron Leventhal
parente: review+
Details | Diff | Splinter Review
Changes to nsAccessibilityService: 1) Check namespace of <svg> and <math>, 2) Always use role to create object unless special role=presentation, 3) Remove unnecessary arg from GetRole() (10.26 KB, patch)
2005-09-27 14:15 PDT, Aaron Leventhal
no flags Details | Diff | Splinter Review
Changes to nsAccessibilityService: 1) Check namespace of <svg> and <math>, 2) Always use role to create object unless special role=presentation, 3) Remove unnecessary arg from GetRole() (8.29 KB, patch)
2005-09-27 14:20 PDT, Aaron Leventhal
parente: review+
tor: superreview+
asa: approval1.8b5-
Details | Diff | Splinter Review

Description Aaron Leventhal 2005-09-21 07:30:36 PDT
Currently MathML and SVG content is available via ISimpleDOMNode, but there is
no way while reading the MSAA tree to know that content has begun.

We can expose a <math> element as ROLE_EQUATION, and an
                <svg> element as ROLE_DIAGRAM
Comment 2 Aaron Leventhal 2005-09-21 12:10:46 PDT
Created attachment 196937 [details] [diff] [review]
Simple patch to expose ROLE_EQUATION for <math> or ROLE_DIAGRAM for <svg>

The screen reader can look at the DOM children of these IAccessibles by using
ISimpleDOMNode (QI to that from IAccessible)
Comment 3 parente 2005-09-22 09:05:38 PDT
Comment on attachment 196937 [details] [diff] [review]
Simple patch to expose ROLE_EQUATION for <math> or ROLE_DIAGRAM for <svg>

Is the comment block a few lines up in nsAccessibilityService still valid? Says
tags that aren't html, have tab index, or have an XHTML2 role aren't in the
accessible tree. math and svg are exceptions?

Is putting the implementation of GetRole in nsBaseWidgetAccessible.h
recommended?
Comment 4 Aaron Leventhal 2005-09-22 09:12:20 PDT
Comment on attachment 196937 [details] [diff] [review]
Simple patch to expose ROLE_EQUATION for <math> or ROLE_DIAGRAM for <svg>

Good catch on the comment. I don't think it matters if we do inline methods for
really simple stuff. We do that all over the place in Gecko.
Comment 5 Aaron Leventhal 2005-09-27 14:15:51 PDT
Created attachment 197612 [details] [diff] [review]
Changes to nsAccessibilityService: 1) Check namespace of <svg> and <math>, 2) Always use role to create object unless special role=presentation, 3) Remove unnecessary arg from GetRole()
Comment 6 Aaron Leventhal 2005-09-27 14:20:47 PDT
Created attachment 197615 [details] [diff] [review]
Changes to nsAccessibilityService: 1) Check namespace of <svg> and <math>, 2) Always use role to create object unless special role=presentation, 3) Remove unnecessary arg from GetRole()
Comment 7 parente 2005-09-27 17:57:26 PDT
Comment on attachment 197615 [details] [diff] [review]
Changes to nsAccessibilityService: 1) Check namespace of <svg> and <math>, 2) Always use role to create object unless special role=presentation, 3) Remove unnecessary arg from GetRole()

What are objects with roles ending in :presentation?
Comment 8 Aaron Leventhal 2005-09-27 19:14:07 PDT
(In reply to comment #7)
> (From update of attachment 197615 [details] [diff] [review] [edit])
> What are objects with roles ending in :presentation?

That's the DHTML a11y way of removing an object from the accessibility
hierarchy. The author is saying that it is there for presentation only. Thus
<table xhtml2:role="wairole:presentation"> is a table used only for layout, not
for data.

Comment 9 Asa Dotzler [:asa] 2005-10-05 11:43:48 PDT
Comment on attachment 197615 [details] [diff] [review]
Changes to nsAccessibilityService: 1) Check namespace of <svg> and <math>, 2) Always use role to create object unless special role=presentation, 3) Remove unnecessary arg from GetRole()

we're now locked down and in ship mode for 1.8b5. If you'd like to re-request
approval for this change, please set the approval1.8rc1? flag.
Comment 10 Aaron Leventhal 2005-10-05 12:45:20 PDT
Sorry, this was checked into the branch on 9/30 (fixed in 10/1 build).

Note You need to log in before you can comment on or make changes to this bug.